package categoryhttp

import (
	authmiddleware "legalgo-BE-go/internal/api/http/middleware/auth"
	categorydomain "legalgo-BE-go/internal/domain/category"
	categorysvc "legalgo-BE-go/internal/services/category"
	"legalgo-BE-go/internal/utilities/response"
	"legalgo-BE-go/internal/utilities/utils"
	"net/http"

	"github.com/go-chi/chi/v5"
	"github.com/go-playground/validator/v10"
)

func Create(
	router chi.Router,
	validate *validator.Validate,
	categorySvc categorysvc.Category,
) {
	router.
		With(authmiddleware.Authorize()).
		Post("/category/create", func(w http.ResponseWriter, r *http.Request) {
			ctx := r.Context()

			var spec categorydomain.CategoryReq

			if err := utils.UnmarshalBody(r, &spec); err != nil {
				response.ResponseWithErrorCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.Error(),
				)

				return
			}

			if err := validate.Struct(spec); err != nil {
				response.ResponseWithErrorCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.(validator.ValidationErrors).Error(),
				)
				return
			}

			if err := categorySvc.Create(spec); err != nil {
				response.ResponseWithErrorCode(
					ctx,
					w,
					err,
					response.ErrCreateEntity.Code,
					response.ErrCreateEntity.HttpCode,
					err.Error(),
				)
				return
			}

			response.RespondJsonSuccess(ctx, w, struct {
				Message string
			}{
				Message: "category created successfully",
			})
		})
}
